VERSION 5.00
Begin VB.Form frmLimitEdit 
   AutoRedraw      =   -1  'True
   Caption         =   "Limit Edit Control Entries"
   ClientHeight    =   3315
   ClientLeft      =   3210
   ClientTop       =   1530
   ClientWidth     =   5610
   Icon            =   "frmLimitEdit.frx":0000
   LinkTopic       =   "Form1"
   OLEDropMode     =   1  'Manual
   ScaleHeight     =   221
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   374
   Begin VB.ComboBox cbRealNumbers 
      Height          =   315
      ItemData        =   "frmLimitEdit.frx":000C
      Left            =   660
      List            =   "frmLimitEdit.frx":0022
      TabIndex        =   6
      Top             =   2730
      Width           =   3960
   End
   Begin VB.TextBox txTest 
      Height          =   300
      Index           =   2
      Left            =   660
      TabIndex        =   2
      Top             =   1890
      Width           =   3945
   End
   Begin VB.TextBox txTest 
      Height          =   300
      Index           =   1
      Left            =   660
      TabIndex        =   1
      Top             =   1125
      Width           =   3945
   End
   Begin VB.TextBox txTest 
      Height          =   300
      Index           =   0
      Left            =   660
      TabIndex        =   0
      Top             =   405
      Width           =   3945
   End
   Begin VB.Label Label1 
      Caption         =   "Limit to real numbers.  This works with any edit control"
      Height          =   225
      Index           =   3
      Left            =   660
      TabIndex        =   7
      Top             =   2490
      Width           =   4365
   End
   Begin VB.Label Label1 
      Caption         =   "Do not allow right click context menu"
      Height          =   225
      Index           =   2
      Left            =   660
      TabIndex        =   5
      Top             =   1635
      Width           =   3855
   End
   Begin VB.Label Label1 
      Caption         =   "Limit to real numbers and allow negitive numbers"
      Height          =   225
      Index           =   1
      Left            =   660
      TabIndex        =   4
      Top             =   885
      Width           =   3855
   End
   Begin VB.Label Label1 
      Caption         =   "Limit to decimal number and do not allow pasting"
      Height          =   225
      Index           =   0
      Left            =   660
      TabIndex        =   3
      Top             =   135
      Width           =   3855
   End
End
Attribute VB_Name = "frmLimitEdit"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
  Option Explicit
  ' demo project showing how to subclass the WM_CHAR and WM_PASTE
  ' messages to limit the text that can be entered into a textbox
  ' by Bryan Stafford of New Vision Software - newvision@mvps.org
  ' this demo is released into the public domain "as is" without
  ' warranty or guaranty of any kind.  In other words, use at
  ' your own risk.
  '
  '   Copyright  2000  Bryan Stafford/New Vision Software
  '
  ' the code in this demo is copyrighted and may only be used in
  ' accordance with the rules set forth in the "House Rules"
  ' section of the web page found at http://www.mvps.org/vbvision/


  ' enum to map our control array....
  Private Enum CONTROL_MAP
    cmDecimalNumbers = 0&
    cmRealNumbers
    cmNoContextMenu
  End Enum
  
  ' the handle to the edit control of the combobox
  Private m_hCBEdit As Long
  
Private Sub Form_Load()

  ' limit the text that can be entered in the textboxes
  With g_oLimitEditControlEntries
    .AddLimitedItem txTest(cmDecimalNumbers).hWnd, eDecimal Or eDoNotAllowPaste
    .AddLimitedItem txTest(cmRealNumbers).hWnd, eRealNumber Or eAllowNegitiveNumbers
    .AddLimitedItem txTest(cmNoContextMenu).hWnd, eDoNotAllowContextMenu

    ' get the hWnd of the edit control within the combo so that we can subclass it directly....
    m_hCBEdit = FindWindowEx(cbRealNumbers.hWnd, 0&, "Edit", vbNullChar)
    
    If m_hCBEdit Then .AddLimitedItem m_hCBEdit, eRealNumber
  End With
  
End Sub

Private Sub Form_Unload(Cancel As Integer)

  ' clean up before we exit
  With g_oLimitEditControlEntries
    .RemoveLimits txTest(cmDecimalNumbers).hWnd
    .RemoveLimits txTest(cmRealNumbers).hWnd
    .RemoveLimits txTest(cmNoContextMenu).hWnd
    
    If m_hCBEdit Then .RemoveLimits m_hCBEdit
  End With

End Sub
